<?php 

	define( 'WOO_DIR', plugin_dir_path( __FILE__ )); 
	
	class Cliente{

	
		//Funciones para llamar a los servicios web de PagosNet

		/**
		 * Metodo para registrar una recaudacion en PagosNet
		 * @param type $client Instancia del cliente SOAP
		 * @param type $params Parametros para registrar una recaudacion en PagosNet.
		 */
		public function registroPlan($client, $params) {
			$metodo = 'registroPlan';
		    $response = $client->__soapCall($metodo, array($params));

		    //escribo el request y el response de la invocación. Esta información puede servir de log
    		//posteriormente
		    $this->escribirHandler($client->__getLastRequest(), $metodo, 'Request');
		    $this->escribirHandler($client->__getLastResponse(), $metodo, 'Response');


		    //Para comodidad, paso de objeto a array
		    $responseRegistroPlan = $this->obj2array($response);
		    return $responseRegistroPlan;

		}


			/**
		 * Metodo para registrar datos de un tarjetahabiente.
		 * @param type $client Instancia del cliente SOAP
		 * @param type $params Parametros para realizar el consumo del servicio web.
		 * @return type
		 */
		function registroTarjetaHabiente($client, $params) {
		    //invoco el servicio
		    $metodo = 'registroTarjetaHabiente';
		    $response = $client->__soapCall($metodo, array($params));

		    //escribo el request y el response de la invocación. Esta información puede servir de log
		    //posteriormente
		    $this->escribirHandler($client->__getLastRequest(),  $metodo, 'Request');
		    $this->escribirHandler($client->__getLastResponse(), $metodo, 'Response');

		    //Para comodidad, paso de objeto a array
		    $responseRegistroTarjetaHabiente = $this->obj2array($response);
		    return $responseRegistroTarjetaHabiente;
		}



		//Funciones auxiliares 

		  public function obj2array($obj) {
		    $out = array();
		    foreach ($obj as $key => $val) {
		      switch(true) {
		        case is_object($val):
			  $out[$key] = $this->obj2array($val);
			  break;
			case is_array($val):
			  $out[$key] = $this->obj2array($val);
			  break;
			default:
			  $out[$key] = $val;
		      }
		    }
		    return $out;
		  }


		public function escribirHandler($raw_xml, $metodo, $tipo){
		  if ($raw_xml == null){
				return;
		  }	
		  $doc = new DOMDocument();
		  $doc->formatOutput = TRUE;
		  $doc->loadXML($raw_xml);
		  $newxml = $doc->saveXML();
		  
		  $outputFilename   = WOO_DIR . 'includes/log/handler_' . date("Ymd") .'.txt';
		  $handle = fopen($outputFilename, "a");
		  fwrite($handle, '******************************************************' . PHP_EOL);
		  fwrite($handle, 'Método: ' . $metodo .  PHP_EOL);
		  fwrite($handle, 'Hora: ' .  date("H:i:s") . PHP_EOL);
		  fwrite($handle, 'Tipo: ' . $tipo . PHP_EOL);
		  fwrite($handle, $newxml);
		  fwrite($handle, PHP_EOL);
		  fclose($handle);	
		}


		}

	

?>